package cn.jyjz.xiaoyao.common.redis.cache;

import cn.jyjz.xiaoyao.common.base.service.UserTokenOnlineService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextClosedEvent;
import org.springframework.stereotype.Component;

/**
 * 程序停止监听，用户系统重启时及时清除在线用户表
 * Created by zhangyong on 2021/6/16.
 */
@Component
public class ApplicationClosedEventListener implements ApplicationListener<ContextClosedEvent> {
    private static Logger logger = LoggerFactory.getLogger(ApplicationClosedEventListener.class);

    @Value("${spring.cache.type}")
    String cacheType;

    @Autowired
    private UserTokenOnlineService userTokenOnlineService;

    @Override
    public void onApplicationEvent(ContextClosedEvent contextClosedEvent) {

        if(StringUtils.isNotBlank(cacheType)){
            this.userTokenOnlineService.deletall();
        }
    }
}
