package cn.jyjz.xiaoyao.common.redis.cache;


import com.alibaba.fastjson.JSONObject;
import java.util.List;

/**
 * Created by zhangyong on 2018/2/27.
 */
public interface ICacheManager {

    /**
     * 查询缓存
     * 根据key获取到一直值
     * @param key 缓存key
     * @return 返回缓存对象
     */
    public <T extends Object> T get(String cacheName, String key);

    /**
     * 查询缓存
     * 根据key获取到一直值
     * @return 返回缓存对象
     */
    public <T extends Object> List<T> get(String cacheName);

    /**
     * 添加缓存
     * 添加一个缓冲数据
     * @param key 缓存key
     * @param value 缓冲的缓存数据
     */
    public void put(String cacheName, String key, Object value);

    /**
     * 添加缓存,
     * 添加一个缓冲数据
     * @param key 缓存key
     * @param value 缓冲的缓存数据
     * @param validTime 超时时间，存活时间，单位：秒
     */
    public void put(String cacheName, String key, Object value, long validTime);

    /**
     * 添加缓存
     * 添加一个缓冲数据
     * @param key 缓存key
     * @param value 缓冲的缓存数据
     * @param saveTime 存活时间
     * @param validTime 超时时间，存活时间
     */
    public void put(String cacheName, String key, Object value, long saveTime, long validTime);

    /**
     * 删除一个缓存数据问题
     * @param key 缓存key
     */
    public void remove(String cacheName, String key);

    public void removeAll(String cacheName);

    public JSONObject getCacheInfo();
}
