package cn.jyjz.xiaoyao.common.redis.cache.ehcache;

import org.springframework.boot.autoconfigure.cache.CacheProperties;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.cache.ehcache.EhCacheCacheManager;
import org.springframework.cache.ehcache.EhCacheManagerUtils;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.Resource;

@Configuration
@ConditionalOnProperty(prefix = "spring.cache", name = "type", havingValue = "ehcache", matchIfMissing = true)
@EnableConfigurationProperties(CacheProperties.class)
public class EchcacheCacheManagerConfig {

    /**
     * 创建ehCacheCacheManager
     */
    @Bean
    public EhCacheCacheManager ehCacheCacheManager(CacheProperties cacheProperties) {

        Resource p = cacheProperties.getEhcache().getConfig();
        Resource location = cacheProperties.resolveConfigLocation(p);

        EhCacheCacheManager manager = new EhCacheCacheManager(EhCacheManagerUtils.buildCacheManager(location));


        return manager;
    }
}