package cn.jyjz.xiaoyao.common.redis.cache.ehcache.listener;

import cn.jyjz.xiaoyao.common.redis.cache.CacheListenerIngerface;
import cn.jyjz.xiaoyao.common.redis.cache.constants.CacheConstants;
import cn.jyjz.xiaoyao.common.base.util.SpringUtils;
import java.util.Properties;
import net.sf.ehcache.CacheException;
import net.sf.ehcache.Ehcache;
import net.sf.ehcache.Element;
import net.sf.ehcache.event.CacheEventListenerFactory;


/**
 * Created by zhangyong on 2021/6/4.
 */
public class CacheEventListener extends CacheEventListenerFactory implements net.sf.ehcache.event.CacheEventListener{

    private static CacheEventListener cacheEventListener;
    private CacheListenerIngerface cacheListenerIngerface;
    public CacheEventListener() {

        cacheListenerIngerface =  SpringUtils.getBean(CacheListenerIngerface.class);
        cacheEventListener = cacheEventListener == null ? this : cacheEventListener;
    }

    @Override
    public void notifyElementRemoved(Ehcache cache, Element element) throws CacheException {

        if(cache.getName().lastIndexOf(CacheConstants.USER_MODEL_NAME) >= 0){
            Object key = element.getObjectKey();
            cacheListenerIngerface.removeCache(key.toString());
        }
    }

    @Override
    public void notifyElementPut(Ehcache cache, Element element) throws CacheException {
        // TODO Auto-generated method stub
    }

    @Override
    public void notifyElementUpdated(Ehcache cache, Element element) throws CacheException {

    }

    @Override
    public void notifyElementExpired(Ehcache cache, Element element) {

        if(cache.getName().lastIndexOf(CacheConstants.USER_MODEL_NAME) >= 0){
            Object key = element.getObjectKey();
            cacheListenerIngerface.removeCache(key.toString());
        }
    }

    @Override
    public void notifyElementEvicted(Ehcache cache, Element element) {

    }

    @Override
    public void notifyRemoveAll(Ehcache cache) {
//        // TODO Auto-generated method stub
//        String name = cache.getCacheConfiguration().getName();
//
//        List list = cache.getKeys();
//
//        String names[] = cache.getCacheManager().getCacheNames();
//        System.out.println("notifyRemoveAll");
    }

    @Override
    public void dispose() {

    }

    @Override
    public net.sf.ehcache.event.CacheEventListener createCacheEventListener(Properties properties) {
        return cacheEventListener;
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }
}
