package cn.jyjz.xiaoyao.common.redis.cache.redis;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.UnsupportedEncodingException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SerializeUtil {

    private static Logger logger = LoggerFactory.getLogger(SerializeUtil.class);
    //对象序列化为字符串
    public static String objectSerialiable(Object obj){
        String serStr = null;
        try {
            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            ObjectOutputStream objectOutputStream = new ObjectOutputStream(byteArrayOutputStream);
            objectOutputStream.writeObject(obj);
            serStr = byteArrayOutputStream.toString("ISO-8859-1");
            serStr = java.net.URLEncoder.encode(serStr, "UTF-8");

            objectOutputStream.close();
            byteArrayOutputStream.close();
        } catch (UnsupportedEncodingException e) {
            logger.error("e={}",e);
        } catch (IOException e) {
            logger.error("e={}",e);
        }

        return serStr;
    }

    //字符串反序列化为对象
    public static Object objectDeserialization(String serStr){
        Object newObj = null;
        try {
            String redStr = java.net.URLDecoder.decode(serStr, "UTF-8");
            ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(redStr.getBytes("ISO-8859-1"));
            ObjectInputStream objectInputStream = new ObjectInputStream(byteArrayInputStream);
            newObj = objectInputStream.readObject();
            objectInputStream.close();
            byteArrayInputStream.close();
        } catch (UnsupportedEncodingException e) {
            logger.error("e={}",e);
        } catch (ClassNotFoundException e) {
            logger.error("e={}",e);
        } catch (IOException e) {
            logger.error("e={}",e);
        }
        return newObj;
    }

    //测试
    public static void main(String[] args) {
        //构造一个list
//        List<HashMap<String, String>> list = new ArrayList<HashMap<String, String>>();
//        HashMap<String, String> map = new HashMap<String, String>();
//        map.put("number", "王小二");
//        map.put("name", "王二");
//        list.add(map);
//        HashMap<String, String> map2 = new HashMap<String, String>();
//        map2.put("number", "张三");
//        map2.put("name", "张小三");
//        list.add(map2);

//        User map = JSONObject.parseObject("{\"card\":\"610422197605311131\",\"cardtype\":1,\"createdate\":1603183509000,\"department\":{\"cutoffdate\":1603241037572,\"departaddress\":\"\u5317\u4eac\u6559\u80b2\u96c6\u56e2\u5730\u5740\",\"departdesc\":\"\u5317\u4eac\u6559\u80b2\u96c6\u56e2\u8bf4\u660e\",\"departname\":\"\u5317\u4eac\u6559\u80b2\u96c6\u56e2\",\"departroot\":\"-1\",\"departshotname\":\"\u4e2d\u6559\",\"deptno\":\"BJ\",\"deptstatus\":0,\"dlevel\":0,\"enabled\":1,\"id\":\"0\",\"parentid\":\"-1\",\"shuwpcac\":\"\u7cfb\u7edf\",\"sorting\":1,\"userid\":\"1\"},\"departmentId\":\"0\",\"departmentRootId\":\"0\",\"departname\":\"\u5317\u4eac\u6559\u80b2\u96c6\u56e2\",\"deptlist\":[{\"$ref\":\"$.department\"}],\"email\":\"18010127548@163.com\",\"enabled\":1,\"id\":\"4028803c73c6d4140173c7ad78680013\",\"issys\":0,\"loginname\":\"lee001\",\"mobile\":\"17746582107\",\"nationid\":\"1\",\"password\":\"\",\"perfect\":1,\"resourceMap\":{},\"resourceNav\":{},\"rolesShowleave\":{},\"roleslist\":[{\"deptid\":\"0\",\"enabled\":1,\"id\":\"systemuser\",\"ishave\":false,\"issys\":0,\"othertype\":0,\"roledesc\":\"\u7cfb\u7edf\u7528\u6237\",\"rolename\":\"\u7cfb\u7edf\u7528\u6237\",\"showleavel\":0,\"sorting\":0,\"userid\":\"1\"}],\"rolesname\":\"\u7cfb\u7edf\u7528\u6237\",\"rootResource\":\"[]\",\"rootResourceList\":[],\"searchQueryrolesShowleave\":{\"query\":{}},\"sorting\":0,\"uaddress\":\"\",\"ubirthday\":1603123200000,\"userSchoolDetailt\":{\"areaid\":\"110114\",\"brandname\":\"\",\"changeremark\":\"\",\"cityid\":\"110100\",\"classid\":\"\",\"companyname\":\"\",\"completebookcode\":\"\",\"grade\":\"\",\"id\":\"8a7483c27544c57d0175452eff7a0000\",\"jobyear\":\"\",\"learmyears\":\"\",\"level\":\"\",\"markes\":\"\",\"overtime\":1603123200000,\"politics\":\"\",\"provinceid\":\"110000\",\"record\":\"\",\"schoolid\":\"4028803c73c6d4140173c7a9ef060011\",\"schoolnum\":\"\",\"status\":\"\",\"studentclass\":\"\",\"studysection\":\"\",\"subject\":\"\",\"userid\":\"4028803c73c6d4140173c7ad78680013\",\"userjob\":\"\",\"userpost\":\"\"},\"usericon\":\"/static/icon/admin.jpeg\",\"userid\":\"1\",\"username\":\"lee001_gai\",\"usertype\":1,\"usex\":\"1\"}",User.class);
//
//        //map.setId("1234");
//        //将对象序列化为字符串
//        String serStr = objectSerialiable(map);
//        System.out.println(serStr);


//        List<HashMap<String, String>> listtemp = (List<HashMap<String, String>>) objectDeserialization(serStr);
//
//
//        System.out.println("2222");

    }
}