package cn.jyjz.xiaoyao.common.redis.cache.redis.listener;

import cn.jyjz.xiaoyao.common.redis.cache.CacheListenerIngerface;
import cn.jyjz.xiaoyao.common.redis.cache.constants.CacheConstants;
import cn.jyjz.xiaoyao.common.redis.config.CacheProperties;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.data.redis.connection.Message;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.listener.KeyspaceEventMessageListener;
import org.springframework.data.redis.listener.RedisMessageListenerContainer;
import org.springframework.stereotype.Component;


/**
 * Created by zhangyong on 2021/6/7.
 */
@Component
@ConditionalOnClass({RedisMessageListenerContainer.class})
@ConditionalOnProperty(prefix = "spring.cache", name = "type", havingValue = "redis", matchIfMissing = false)
public class ReMessageListener extends KeyspaceEventMessageListener{

    private Logger log = LoggerFactory.getLogger(this.getClass());
    @Autowired
    private RedisTemplate redisTemplate;

    @Autowired
    private CacheProperties cacheProperties;

    @Autowired
    private CacheListenerIngerface cacheListenerIngerface;

    public ReMessageListener(RedisMessageListenerContainer listenerContainer) {
        super(listenerContainer);
    }

    @Override
    protected void doHandleMessage(Message message) {
        String channel = new String(message.getChannel());
        if (channel.equals("__keyevent@0__:del")) {

            String body = new String(message.getBody());

            String tempname = (cacheProperties.getPrefix() + "{" + CacheConstants.USER_MODEL_NAME);

            //TODO 测试没成功
            if(body.indexOf(tempname) >= 0){

                String token = body.substring(body.lastIndexOf("}")+1);

                if(token.indexOf(cacheProperties.getCacheNamePrix() + cacheProperties.getCacheNameTimePrix()) > 0){

                    token = token.substring(0,token.lastIndexOf(cacheProperties.getCacheNamePrix() + cacheProperties.getCacheNameTimePrix()));
                }

                cacheListenerIngerface.removeCache(token);
            }
        }
    }


}
